package	jp.co.sds_corp.util.calc;


/**
* 計算式の要素を保持します。
*/
public class FunctionNode extends CalcNode
{
	Function	func;

	public FunctionNode( Function func ) {
		this.func = func;
		type = TYPE_FUNCTION;
	}

	public FunctionNode( String name, CalcNode[] param ) {
		this( new Function( name, param ));
	}

	public Function getFunction() {
		return func;
	}

	public String toString() {
		StringBuilder ret = new StringBuilder();
		ret.append(func.getName() + "(");
		for ( int i = 0; i < func.getParam().length; i++ ) {
			if ( i > 0 ) {
				ret.append( "," );
			}
			ret.append( func.getParam()[i].toString());
		}
		ret.append( ")" );
		return ret.toString();
	}

}
