package	jp.co.sds_corp.util.common;

import java.util.Locale;

/**
* Localeを取得します。
* user.language,user.countryから取得するだけではなく
* Localeを設定したい場合に使用します。
* @author	小見山　聡
*/
public class CmnLocale
{
	private	static Locale	loc;
	static {
		loc  = Locale.getDefault();
		try {
			if ( System.getProperty( "user.language" ) != null &&
					System.getProperty( "user.country" ) != null )
			{
				loc = new Locale( System.getProperty( "user.language" ),
									System.getProperty( "user.country" ) );
			}
		} catch ( Exception ex ) {
		}
	};

	/**
	* 現在設定されている Locale を取得します。
	* @return	現在設定されているLocale
	*/
	public static Locale getLocale() {
		return loc;
	}

	/**
	* Localeを設定します。
	* @param	aLoc		新しいLocale
	*/
	public static void setLocale( Locale aLoc ) {
		loc = aLoc;
	}
}

