package	jp.co.sds_corp.util.common;

import jp.co.sds_corp.util.log.CmnLogger;

/**
* ログを出力します。
* このクラスは、互換性のためにのみ存在します。
* jp.co.sds_corp.util.log.CmnLoggerを使用してください。
* @author	小見山　聡
* @deprecated
*/
public class CmnLog
{
	static CmnLogger logger = CmnLogger.getInstance();

	private CmnLog() {
	}

	/**
	* log4j の設定を変更します。
	* @param	file	log4j の設定ファイル
	* @deprecated
	*/
	public static void configure( String file ) {
	}

	/**
	* debug log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	*/
	public static void debug( Object obj, String logMsg ) {
		logger.debug( obj, logMsg );
	}
	/**
	* debug log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	* @param	t		出力する例外
	*/
	public static void debug( Object obj, String logMsg, Throwable t ) {
		logger.debug( obj, logMsg, t );
	}
	/**
	* info log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	*/
	public static void info( Object obj, String logMsg ) {
		logger.info( obj, logMsg );
	}
	/**
	* info log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	* @param	t		出力する例外
	*/
	public static void info( Object obj, String logMsg, Throwable t ) {
		logger.info( obj, logMsg, t );
	}
	/**
	* warn log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	*/
	public static void warn( Object obj, String logMsg ) {
		logger.warn( obj, logMsg );
	}
	/**
	* warn log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	* @param	t		出力する例外
	*/
	public static void warn( Object obj, String logMsg, Throwable t ) {
		logger.warn( obj, logMsg, t );
	}
	/**
	* error log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	*/
	public static void error( Object obj, String logMsg ) {
		logger.error( obj, logMsg );
	}
	/**
	* error log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	* @param	t		出力する例外
	*/
	public static void error( Object obj, String logMsg, Throwable t ) {
		logger.error( obj, logMsg, t );
	}
	/**
	* fatal log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	*/
	public static void fatal( Object obj, String logMsg ) {
		logger.fatal( obj, logMsg );
	}
	/**
	* fatal log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	logMsg	出力するメッセージ
	* @param	t		出力する例外
	*/
	public static void fatal( Object obj, String logMsg, Throwable t ) {
		logger.fatal( obj, logMsg, t );
	}

	/**
	* exception log を出力します。
	* @param	obj		出力する例外
	*/
	public static void exception( Throwable obj ) {
		logger.exception( obj );
	}

	/**
	* SQL log を出力します。
	* @param	obj		log の出力を行なったClass。
	* @param	sql		出力するSQL
	*/
	public static void sql( Object obj, String sql ) {
		logger.sql( obj, sql );
	}

}
