package	jp.co.sds_corp.util.common;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import jp.co.sds_corp.util.log.CmnLogFactory;
import	jp.co.sds_corp.util.log.CmnLogger;

/**
* アプリケーションの実行環境に関する操作を行ないます。
*/
public class CmnRuntime
{
	/**
	* 子プロセスを起動します。
	* @param	obj		起動を要求したクラスを指定します。
	* @param	cmd		起動するコマンド文字列を指定します。
	* @exception	IllegalStateException	子プロセスの終了コードが0以外の場合
	*/
	public static int execChild( Object obj, String cmd ) throws Exception {
		CmnLogger logger = CmnLogFactory.getInstance().getLogger(obj);
		logger.debug( "execute command:" + cmd );
		Process proc = Runtime.getRuntime().exec( cmd );
		BufferedReader br = new BufferedReader(
			new InputStreamReader( proc.getInputStream() ));
		for ( ;; ) {
			String line = br.readLine();
			if ( line == null ) {
				break;
			}
			logger.debug( "exec:" + line );
		}
		int nExit = proc.waitFor();
		if ( nExit != 0 ) {
			throw( new IllegalStatusException( "abnormal end. "
									+ "status=" + nExit
									+ " cmd=" + cmd ));
		}
		logger.debug( "status:" + nExit );
		return nExit;
	}
}
