package	jp.co.sds_corp.util.device;


/**
* JNIを使用してデバイスの情報を取得します。
*/
public class DeviceManager
{
	static {
		System.loadLibrary( "sdsjni" );
	}

	/**
	* 接続されているドライブの一覧を取得します。
	*/
	public static native DriveInfo[] getAllDriveInfo();

	/**
	* 指定されたドライブの情報を取得します。
	* @param	name	ドライブ名
	*/
	public static native DriveInfo getDriveInfo( String name );

	/**
	* メモリの使用状況を取得します。
	*/
	public static native MemoryUsage getMemoryUsage();

	/**
	* CPUの使用状況を取得します。
	*/
	public static native CPUStatus getCPUStatus( int sec );

	/**
	* 起動中の全てのプロセスの情報を取得します。
	*/
	public static native ProcessInfo[] getAllProcessInfo();
	/**
	* 指定されたプロセスの状況を取得します。
	*/
	public static native ProcessInfo getProcessInfo( int pid );
	/**
	* 起動中のプロセスの数を取得します。
	*/
	public static native int getProcessCount();
}
