package	jp.co.sds_corp.util.log;

import java.util.logging.Level;
import java.util.logging.LogRecord;

public class CmnLogRecord extends LogRecord
{
	private static final long serialVersionUID = 1L;
	boolean	needcaller;
	int	lineNumber = 0;

	public CmnLogRecord( Level level, String msg ) {
		super( level, msg );
		needcaller = true;
	}

	void setNeedCaller( boolean needcaller ) {
		this.needcaller = needcaller;
	}

	public String getSourceClassName() {
		if ( needcaller ) {
			getCaller();
		}
		return super.getSourceClassName();
	}

	public void setSourceClassName( String sourceClassName ) {
		super.setSourceClassName( sourceClassName );
		needcaller = false;
	}

	public String getSourceMethodName() {
		if ( needcaller ) {
			getCaller();
		}
		return super.getSourceMethodName();
	}

	public void setSourceMethodName( String sourceMethodName ) {
		super.setSourceMethodName( sourceMethodName );
		needcaller = false;
	}

	public int getSourceLineNumber() {
		getSourceMethodName();
		return lineNumber;
	}

	private void getCaller() {
		StackTraceElement stack[] = (new Throwable()).getStackTrace();
		int ix = 0;
		while ( ix < stack.length ) {
			StackTraceElement frame = stack[ix];
			String cname = frame.getClassName();
			if ( cname.equals( "jp.co.sds_corp.util.log.CmnLogger" )) {
				break;
			}
			ix++;
		}
		while ( ix < stack.length ) {
			StackTraceElement frame = stack[ix];
			String cname = frame.getClassName();
			if ( !cname.equals( "jp.co.sds_corp.util.log.CmnLogger" ) &&
				!cname.equals( "jp.co.sds_corp.util.common.CmnLog" ))
			{
				String clazz = frame.getClassName();
				String method = frame.getMethodName()
								+ "(" + frame.getLineNumber() + ")";
				setSourceClassName( clazz );
				setSourceMethodName( method );
				lineNumber = frame.getLineNumber();
				return;
			}
			ix++;
		}
		return;
	}

}
