package	jp.co.sds_corp.util.math;

import java.math.BigDecimal;
import java.util.Vector;

/**
* 最小二乗法近似
*/
public class Lsm
{
	double a[][];
	double af[];
	double f[];
	Vector<BigDecimal> aF = new Vector<BigDecimal>();

	public Lsm() {
	}

	public void createWork(int order) {
		a = new double[order+1][order+1];
		f = new double[order+1];
		af = new double[order+1];
	}

	public Vector calc(int order, Vector sample_x, Vector sample_y) {
		int m = order;
		double x,y,aa,bb,p,q,w;
		int iw;
		if (m >= sample_x.size()) {
			m = sample_x.size() - 1;
		}
		int nn = m + 1;

		createWork(order);
		for (int i=1; i<=nn; i++) {
			for (int j=1; j<=nn; j++) {
				a[i][j] = 0;
				for (int k=0; k<sample_x.size(); k++) {
					x = ((BigDecimal)sample_x.get(k)).doubleValue();
					a[i][j] = a[i][j] + Math.pow(x, m-i+1) *
									  + Math.pow(x, m-j+1);
							  
				}
			}

			f[i] = 0;
			for( int k=0; k<sample_x.size(); k++) {
				x = ((BigDecimal)sample_x.get(k)).doubleValue();
				y = ((BigDecimal)sample_y.get(k)).doubleValue();
				f[i] += Math.pow(x, m-i+1) * y;
			}
		}

		for (int k=1; k<=nn-1; k++) {
			w = Math.abs(a[k][k]);
			iw = k;
			for (int i=k+1; i<=nn; i++) {
				if (w < Math.abs(a[i][k])) {
					iw = i;
					w = Math.abs(a[i][k]);
				}
			}

			if (iw != k) {
				for (int j=k; j<=nn; j++) {
					aa = a[k][j];
					bb = a[iw][j];
					a[k][j] = bb;
					a[iw][j] = aa;
				}
				aa = f[k];
				bb = f[iw];
				f[k] = bb;
				f[iw] = aa;
			}
			p=a[k][k];
            
			for (int i=k+1; i<=nn; i++) {
				q = a[i][k] / p;
				for (int j=k+1; j<=nn; j++) {
					a[i][j] = a[i][j]-q * a[k][j];
				}
				f[i] =f[i] - q * f[k];
			}
		}

		af[nn] = f[nn] / a[nn][nn];
		for (int i=1; i<=nn-1; i++) {
			int i_tmp = nn - i;
			w = f[i_tmp];
			for (int j=i_tmp+1; j<=nn; j++) {
				w = w - a[i_tmp][j] * af[j];
			}
			af[i_tmp] = w / a[i_tmp][i_tmp];
		}

for (int i=1; i<=nn; i++) {
	for (int j=1; j<=nn; j++) {
		System.out.println("a[" + i + "]" + "[" + j + "]=" + a[i][j]);
	}
}

		for (int i=0; i<=nn; i++) {
			aF.add(new BigDecimal(af[i]));
		}
		return aF;
	}
}
