package	jp.co.sds_corp.util.math;


/**
* 正規分布
*/
public class NormalDistribution
{
	/**
	* 累積確率(下側)
	*/
	public static double lower(double z) {
		double z2 = z * z;
		double t = z * Math.exp(-0.5 * z2) / Math.sqrt(2 * Math.PI);
		double p = t;

		for (int i=3; i<200; i+=2) {
			double prev = p;
			t *= z2 / i;
			p += t;
			if (p == prev) {
				return 0.5 + p;
			}
		}
		return (z > 0) ? 1 : 0;
	}

	/**
	*  累積確率(上側)
	*/
	public static double upper(double z) {
		return 1 - lower(z);
	}
}
